unit ListFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ImgList, CRVData, RVItem, RVStyle;

type

  THyperlinkLocation = class
    public
      RVData: TCustomRVData;
      ItemNo: Integer;
  end;


  TfrmList = class(TForm)
    ImageList1: TImageList;
    ListView1: TListView;
    Button1: TButton;
    Button2: TButton;
    procedure FormDestroy(Sender: TObject);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure ListView1DblClick(Sender: TObject);
  private
    { Private declarations }
    procedure EnumLinks(RVData: TCustomRVData; ItemNo: Integer;
      var UserData1: Integer; const UserData2: String;
      var ContinueEnum: Boolean);
  public
    { Public declarations }
    function Init(RVData: TCustomRVData): Boolean;
    function GetLocation(var RVData: TCustomRVData; var ItemNo: Integer): Boolean;
  end;


implementation

{$R *.dfm}

{ TfrmList }

procedure TfrmList.EnumLinks(RVData: TCustomRVData; ItemNo: Integer;
  var UserData1: Integer; const UserData2: String;
  var ContinueEnum: Boolean);
var loc: THyperlinkLocation;
begin
  if RVData.GetItem(ItemNo).GetBoolValueEx(rvbpJump, RVData.GetRVStyle) then
    with ListView1.Items.Add do begin
      // making caption
      Caption := RVData.GetItemText(ItemNo);
      if (Caption='') and (RVData.GetItemStyle(ItemNo)=rvsHotPicture) then
        Caption := '[IMAGE]';
      // adding target
      SubItems.Add(RVData.GetItemTag(ItemNo));
      // making image
      if RVData.GetItemStyle(ItemNo)=rvsHotPicture then
        ImageIndex := 1
      else if RVData.GetItemStyle(ItemNo)>=0 then
        ImageIndex := 0;
      // storing location info
      loc := THyperlinkLocation.Create;
      loc.RVData := RVData.GetSourceRVData;
      loc.ItemNo := ItemNo;
      Data := loc;
    end;
end;
{------------------------------------------------------------------------------}
procedure TfrmList.FormDestroy(Sender: TObject);
var i: Integer;
begin
  for i := 0 to ListView1.Items.Count-1 do
    THyperlinkLocation(ListView1.Items[i].Data).Free;
end;
{------------------------------------------------------------------------------}
function TfrmList.Init(RVData: TCustomRVData): Boolean;
var Unused: Integer;
begin
  ListView1.Items.BeginUpdate;
  try
    // calling EnumLinks for each item in RVData and all its sub-RVData
    RVData.EnumItems(EnumLinks, Unused, '');
  finally
    ListView1.Items.EndUpdate;
  end;
  Result := ListView1.Items.Count>0;
  if Result then
    ListView1.Selected := ListView1.Items[0];
end;
{------------------------------------------------------------------------------}
function TfrmList.GetLocation(var RVData: TCustomRVData;
  var ItemNo: Integer): Boolean;
begin
  Result := ListView1.Selected<>nil;
  if Result then begin
    ItemNo := THyperlinkLocation(ListView1.Selected.Data).ItemNo;
    RVData := THyperlinkLocation(ListView1.Selected.Data).RVData;    
  end;
end;
{------------------------------------------------------------------------------}
procedure TfrmList.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
  Button1.Enabled := ListView1.Selected<>nil;
end;
{------------------------------------------------------------------------------}
procedure TfrmList.ListView1DblClick(Sender: TObject);
begin
  if ListView1.Selected<>nil then
    ModalResult := mrOk;
end;

end.
