unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RVScroll, RichView, RVEdit, ListFrm, RVStyle, CRVData, CRVFData,
  ShellApi;

type
  TfrmMain = class(TForm)
    RichViewEdit1: TRichViewEdit;
    Button1: TButton;
    RVStyle1: TRVStyle;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RichViewEdit1Jump(Sender: TObject; id: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  RichViewEdit1.LoadRVF(ExtractFilePath(Application.ExeName)+'readme.rvf');
  RichViewEdit1.Format;
end;
{------------------------------------------------------------------------------}
procedure TfrmMain.Button1Click(Sender: TObject);
var frm: TfrmList;
    RVData: TCustomRVData;
    ItemNo, Offs: Integer;
begin
  frm := TfrmList.Create(Application);
  if not frm.Init(RichViewEdit1.RVData) then begin
    Application.MessageBox('No hyperlinks', 'No links', MB_OK or MB_ICONEXCLAMATION);
    frm.Free;
    exit;
  end;
  if (frm.ShowModal=mrOk) and frm.GetLocation(RVData, ItemNo) then begin
    RVData := RVData.Edit;
    Offs := RVData.GetOffsBeforeItem(ItemNo);
    TCustomRVFormattedData(RVData).SetSelectionBounds(ItemNo, Offs, ItemNo, Offs);
    RichViewEdit1.SetFocus;
  end;
  frm.Free;
end;
{------------------------------------------------------------------------------}
{ On hyperlink Ctrl+Click: opening browser }
procedure TfrmMain.RichViewEdit1Jump(Sender: TObject; id: Integer);
var URL: String;
    RVData: TCustomRVFormattedData;
    ItemNo: Integer;
begin
  RichViewEdit1.GetJumpPointLocation(id, RVData, ItemNo);
  URL := PChar(RVData.GetItemTag(ItemNo));
  ShellExecute(0, 'open', PChar(URL), nil, nil, SW_SHOW);
end;

end.
